<?php
if (!defined('FREEPBX_IS_AUTH')) { die('No direct script access allowed'); }

define('WWW_MODULE_DIR', $_SERVER['DOCUMENT_ROOT'].'/phoneMiddleware'); //SAME AS UNINSTALL.PHP AND FUNCTIONS.INC.PHP
define('WWW_MODULE_SYMLINK', $_SERVER['DOCUMENT_ROOT'].'/phonemiddleware'); //SAME AS UNINSTALL.PHP

//read current config file
$inipath = WWW_MODULE_DIR.'/config.ini.php'; //SAME AS FUNCTION.INC.PHP
$iniContent = "";
try {
	$iniContent = file_get_contents($inipath);
}
catch (Exception $e) {
	//file can't be found, this is probably a new installation
}

//delete www folder
try {
	if(file_exists(WWW_MODULE_DIR) && !deleteDir(WWW_MODULE_DIR))
        throw new InvalidArgumentException();
}
catch (InvalidArgumentException $e) {
    die("Installation failed: Unable to delete www module folder. Make sure the module has read/write permissions");
}

//recreate www folder and restore (or create) config file
if(oneTimeInit() && file_put_contents($inipath, $iniContent) !== false && (file_exists(WWW_MODULE_SYMLINK) || symlink(WWW_MODULE_DIR, WWW_MODULE_SYMLINK)))
	echo 'Installation successful. The module is now ready to use.<br>';
else
	die('Failed to initialize working directory. The module won\'t work. Please make sure you have write access to the root PHP folder.<br>');

//-------------------------------
function oneTimeInit($src = null, $dest = WWW_MODULE_DIR) {
    if($src == null)
        $src = dirname(__FILE__).'/module';
	$dir = opendir($src);

	if (!file_exists($dest) && !mkdir($dest))
		return false;
    
    while(false !== ($file = readdir($dir))) {
        if (($file != '.') && ($file != '..')) {
            if (is_dir($src.'/'.$file)) {
                if(!oneTimeInit($src.'/'.$file, $dest.'/'.$file))
					return false;
            }
			else if(!copy($src.'/'.$file, $dest.'/'.$file))
                return false;
        }
    }
    closedir($dir);
	return true;
}

function deleteDir($dirPath) {
	$success = true;
    
    if (!is_dir($dirPath))
        throw new InvalidArgumentException("$dirPath must be a directory");
    
    if (substr($dirPath, strlen($dirPath) - 1, 1) != '/')
        $dirPath .= '/';
    
    $files = glob($dirPath . '{,.}[!.,!..]*', GLOB_MARK|GLOB_BRACE);
    
    foreach ($files as $file) {
        if (is_dir($file))
            $success = deleteDir($file);
        else
            $success = unlink($file);
    }
    $success = rmdir($dirPath);
    
	return $success;
}
?>
